/* isort - sort array a (dimension n) using insertion sort
 */
#include "local.h"
void isort(a, n)
	int a[];
	int n;
	{
	int i;
	int *pj;
	int *pjm;
	int t;

	for (i = 1; i < n; ++i)	/* a[0:i-1]=>sorted */
		{
		t = a[i];
		pj = &a[i];
		pjm = pj - 1;
		while (pj > a && *pjm > t)
			{
			*pj = *pjm;
			--pj;
			--pjm;
			}
		*pj = t;
		}
	/* a=>sorted */
	}
#ifdef TRYMAIN
#include <math.h>
main(ac, av)
	int ac;
	char *av[];
	{
	int i;
	int lim;
	static int a[10000];
	double tim;
	long cputim();

	lim = atoi(av[1]);
	printf("lim=%d\n", lim);
	for (i = 0; i < lim; ++i)
		a[i] = rand();
	cputim();
	isort(a, lim);
	tim = cputim() * 1e6 / 60;
	printf("cpu time = %.3f (sec)\n", tim / 1e6);
	printf("N**2 = %.0f\n", (double)lim * lim);
	printf("cpu time = %.2f N**2 (usec)\n", tim / ((double)lim * lim));
	for (i = 0; i < lim-1; ++i)
		{
		if (a[i] > a[i+1])
			error("bad value", "");
		}
	exit(SUCCEED);
	}
#endif
